#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Version=beta
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Res_Description=Test fr luar-Fehler CHDK-DE Revision 550
#AutoIt3Wrapper_Res_Fileversion=0.1.0.0
#AutoIt3Wrapper_Res_LegalCopyright=GPLv2 (c)2011 by CHDK community
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

;******************************
;Windows Test for ptpcam.exe
;(c)2011 forum.chdk-treff.de
;authors: rudi (main),  msl, CHDKLover
;use with ptpcam.exe and libusb
;******************************


#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <SliderConstants.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <Constants.au3>
#include <GuiSlider.au3>
#include <GUIComboBox.au3>
#include <GUIButton.au3>
#include <GuiStatusBar.au3>
#include <WinAPI.au3>

Opt("TrayIconHide", 1)
Opt("GUIOnEventMode",1)
Opt('MustDeclareVars', 1)

;Const
Const $GUI_VERSION_MAJOR = 0
Const $GUI_VERSION_MINOR = 1
Const $PROG_NAME = "ptp-luar Test"
Const $PROG_TITLE = $PROG_NAME & " " & $GUI_VERSION_MAJOR & "." & $GUI_VERSION_MINOR
Const $CMD_FILENAME = "ptpcam.exe"
Const $M_ATT = "[!!!!] ", $M_INFO = "[Info] ", $M_RES = "[====] ", $M_SEND = "[>>  ] ", $M_RECEIVE = "[  <<] ", $M_OK = " ... OK! ", $M_ERR = " ... FEHLER! "

Enum $GUI_RUN, $GUI_END
Enum $CMD_RESULT_NONE, $CMD_RESULT_NIL, $CMD_RESULT_BOOL, $CMD_RESULT_INT, $CMD_RESULT_STRING, $CMD_RESULT_MULTILINE, $CMD_RESULT_ERROR

;GUI Vars
Global $IniState = False, $TestCount, $TestFinish = 0
Global $GuiRunState = $GUI_RUN
Global $GuiState = $GUI_ENABLE
Global $FMain, $MFile, $MFExit
Global $GDebug, $EDebug, $GTest, $ETest
Global $BStartTest, $BGuiOff
Global $SB

;CHDK Vars
Global $ChdkPlatform, $ChdkInfo

_Main()

Func _Main()

#Region ### START Koda GUI section ### Form=
$FMain = GUICreate($PROG_TITLE, 609, 519, -1, -1, BitOR($WS_SIZEBOX, $WS_SYSMENU, $WS_MINIMIZEBOX))
GUISetOnEvent($GUI_EVENT_CLOSE, "onGuiClose")
;menu
$MFile = GUICtrlCreateMenu("Datei")
$MFExit = GUICtrlCreateMenuItem("Beenden", $MFile)
GUICtrlSetOnEvent($MFExit, "onGuiClose")
;Debug Group
$GDebug = GUICtrlCreateGroup(" PTP-Kommunikation ", 24, 16, 561, 153)
$EDebug = GUICtrlCreateEdit("", 26, 31, 557, 136, BitOR($ES_READONLY, $WS_VSCROLL))
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
GUICtrlCreateGroup("", -99, -99, 1, 1)
;Test Group
$GTest = GUICtrlCreateGroup(" Prfung ", 24, 184, 561, 249)
$ETest = GUICtrlCreateEdit("", 26, 199, 557, 177, BitOR($ES_READONLY, $WS_VSCROLL))
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
$BStartTest = GUICtrlCreateButton("Prfung starten", 248, 392, 107, 25)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
GUICtrlSetOnEvent($BStartTest,"onBStartTest")
GUICtrlCreateGroup("", -99, -99, 1, 1)
;statusBar
$SB = _GUICtrlStatusBar_Create($FMain)
Dim $SB_PartsWidth[3] = [80, 160, -1]
_GUICtrlStatusBar_SetParts($SB, $SB_PartsWidth)
_GUICtrlStatusBar_SetText($SB, "ptpcam:", 0)
_GUICtrlStatusBar_SetText($SB, "kamera:", 1)
_GUICtrlStatusBar_SetText($SB, "", 2)
#EndRegion ### END Koda GUI section ###

changeGuiState($GUI_DISABLE)
GUISetState(@SW_SHOW)
While ($GuiRunState = $GUI_RUN)
	If $GuiState = $GUI_DISABLE Then
		GUICtrlSetData($EDebug, "** Informationen sammeln ..." & @CRLF, 1)
		While Not init()
			If (MsgBox( 32+4, $PROG_TITLE , "Erneut versuchen?") = 7) Then Exit
		WEnd
		GUICtrlSetData($EDebug, "** Informationen zusammengestellt" & @CRLF, 1)
		changeGuiState($GUI_ENABLE)
	Else
		sleep(500)
	EndIf
WEnd
EndFunc	;--End Main

;--functions
;for edit-debug
Func debugWriteLine($text)
	debugWrite($text & @CRLF)
EndFunc

Func debugWrite($text)
	GUICtrlSetData($EDebug, $text , 1)
EndFunc

;for edit-Test
Func testWriteLine($text)
	testWrite($text & @CRLF)
EndFunc

Func testWrite($text)
	GUICtrlSetData($ETest, $text , 1)
EndFunc

;control events
Func onGuiClose()
	;setCommand("shutdown",1)
	$GuiRunState = $GUI_END
EndFunc

Func onBStartTest()
	If $TestFinish Then
		ClipPut("[code]"&GUICtrlRead($ETest)&"[/code]")
	Else
		Opt('GUIOnEventMode', 0)
		GUICtrlSetData($ETest, "")
		ChangeGUIstate($GUI_DISABLE)
		$TestFinish = Not Test()
		If $TestFinish Then
			GUICtrlSetData($BStartTest, "Ergebnis kopieren")
		Else
			testWriteLine(@CRLF&$M_ATT&"Test abgebrochen!")
		EndIf
		ChangeGUIstate($GUI_ENABLE)
		Opt('GUIOnEventMode', 1)
	EndIf
EndFunc

Func setCommand($command, $msg)
; @error<>0 -> command error
; @extended -> type of result (enum CMD_RESULT_...)
;	>hint for CMD_RESULT_MULTILINE: result[0]=rowcount, first value on result[1]
; return value -> result or error-text
	Local $err = 0
    Local $line = "", $res = ""
	Local $resType = $CMD_RESULT_NONE
    debugWrite(">> " & $command)
    Local $con = Run($CMD_FILENAME & ' --chdk='& '"' & $command & '"', "", @SW_HIDE , $STDOUT_CHILD)
	If @error Then
		$line = "Fehler: " & $CMD_FILENAME & " wurde nicht gefunden!"& @CRLF
		$err = -1
	Else
		While 1
			$line = $line & StdoutRead($con)
			If @error Then ExitLoop
		Wend
	EndIf
    $line = StringStripWS($line,2)
    debugWriteLine(" << "& $line & " (Length: " & StringLen($line) & ")")
	$res = $line
	If StringLen($line)>0 Then
		If (StringInStr($line, @CRLF))or(StringInStr($line, @CR))Then
			$res = StringReplace($line, @CRLF, @CR)
			$res = StringSplit($res, @CR)
			$resType = $CMD_RESULT_MULTILINE
		Else
			If $line == "nil" Then
				$res = ""
				$resType = $CMD_RESULT_NIL
			Else
				If ($line == "false")Or($line == "true") Then
					$res = ($line == "true")
					$resType = $CMD_RESULT_BOOL
				Else
					Local $pos1 = StringInStr($line," (")
					Local $pos2 = StringInStr($line,")")
					If ($pos1 > 0)and($pos2 > $pos1)Then
						Local $dec = Int(StringLeft($line, $pos1 -1))
						If $dec = Dec(String(StringMid($line,$pos1+2,$pos2-$pos1-2))) Then
							$res = $dec
							$resType = $CMD_RESULT_INT
						EndIf
					Else
						$resType = $CMD_RESULT_STRING
					EndIf
				EndIf
			EndIf
		EndIf
	EndIf
	If $line == "unknown command" Then
		$res = "unbekannter Befehl"
		$err = 1
	EndIf
	If $line == "execution failed!" Then
		$res = "Ausfhrung fehlgeschlagen!"
		$err = 1
	EndIf
	If $line == "error: couldn't connect to camera." Then
		$res = "Fehler: keine Verbindung zur Kamera"
		$err = -1
	EndIf
    If (StringInStr($line,"error:") > 0) Then $err = -1
	If not $err Then
    	SetExtended($resType)
        Return $res
    EndIf
	If $err < 0 Then ChangeGUIstate($GUI_DISABLE)
	If $msg Then MsgBox(16,$PROG_TITLE & "- Error",$res)
	SetError($err, $CMD_RESULT_ERROR)
    Return $res
EndFunc

Func ChangeGUIstate($newState)
	If $GuiState = $newState Then Return
	GUICtrlSetState($BStartTest, $newState)
	$GuiState=$newState
EndFunc

Func init()
	Local Const $V_EXE = "ptpcam: ", $V_CAM = "camera: "
	Local Const $SS_CAM = "script-support", $SS_CAM_RES = $SS_CAM & ":", $CHDK_CAM_LANG_DE = "CHDK-DE"
	Local $resType
    $IniState = False
    Local $ptp_version = setCommand("version",1)
	If @error Or Not(@extended = $CMD_RESULT_MULTILINE) Then return 0
	If $ptp_version[0] = 2 Then
		Local $vExe = $ptp_version[1]
		Local $vCam = $ptp_version[2]
		If (StringInStr($vExe,$V_EXE)>0)And(StringInStr($vCam,$V_CAM)>0)Then
			_GUICtrlStatusBar_SetText($SB, $vExe, 0)
			_GUICtrlStatusBar_SetText($SB, $vCam, 1)
			If Not(StringTrimLeft($vExe, StringLen($V_EXE))==StringTrimLeft($vCam, StringLen($V_CAM)))Then
				MsgBox(16,$PROG_TITLE & "- Error","Verschiedene Versionen, bitte aktualisieren!"&@CRLF&@CRLF&$vExe&@CRLF&$vCam)
				Return 0
			EndIf
		Else
			Return 0
		EndIf
	Else
		Return 0
	EndIf
	Local $ChdkScriptSupport = setCommand($SS_CAM,1)
	$ChdkScriptSupport = Int(StringTrimLeft($ChdkScriptSupport, StringLen($SS_CAM_RES)))
	If  @error Or(BitAND($ChdkScriptSupport,1)<>1)Then
		MsgBox(16,$PROG_TITLE & "- Fehler","Die LUA untersttzung in CHDK ist erforderlich!")
		Return 0
	EndIf
	setCommand('lua ""',1)
	$ChdkPlatform = setCommand("luar get_buildinfo().platform",1)
    If @error Or Not(@extended = $CMD_RESULT_STRING) Then return 0
	$IniState = True
	Local $ChdkVersion = "_" & setCommand("luar get_buildinfo().platsub",1)
	$ChdkVersion = $ChdkVersion & " "& setCommand("luar get_buildinfo().version",1)
	$ChdkVersion = $ChdkVersion & " [OS: "& setCommand("luar get_buildinfo().os",1)
	$ChdkVersion = $ChdkVersion & ", Build: "& setCommand("luar get_buildinfo().build_number",1)
	$ChdkVersion = $ChdkVersion & " | "& setCommand("luar get_buildinfo().build_date",1)
	$ChdkVersion = $ChdkVersion & " "& setCommand("luar get_buildinfo().build_time",1)&"]"
	$ChdkInfo = StringUpper($ChdkPlatform) & $ChdkVersion
	_GUICtrlStatusBar_SetText($SB, $ChdkInfo, 2)
    Return 1
EndFunc

Func getNextCount()
	$TestCount = $TestCount + 1
	Return  "Prfung"&$TestCount&": "
EndFunc

Func Test()
	Local $TS_BAD = "Fehler aufgetreten", $TS_GOOD = "kein Fehler"
	Local $testStatus = False, $testStatusText = $TS_BAD
	Local $res, $resType, $resErr
	$TestCount = 0
	testWriteLine($M_INFO&"Starte Test (Programm: "&$PROG_TITLE&") ...")
	testWriteLine($M_INFO&"Getestete Kamera: "&$ChdkInfo)

	testWriteLine(@CRLF&getNextCount()&"Kamera wird neu gestartet")
	Local $cmd = "reboot"
	testWriteLine($M_SEND&$cmd)
	$res = setCommand($cmd,1)
	$resType = @extended
	$resErr = @error
	testWrite($M_RECEIVE&$res)
	if $resErr or ($resType <> $CMD_RESULT_NONE) Then
		testWriteLine($M_ERR)
		Return 1
	EndIf
	testWriteLine($M_OK)
;setCommand('lua ""',1)
	testWriteLine(@CRLF&getNextCount()&"luar-Befehl ausfhren")
	$cmd = "luar get_buildinfo().platform"
	testWriteLine($M_SEND&$cmd)
	$res = setCommand($cmd,0)
	$resType = @extended
	$resErr = @error
	testWrite($M_RECEIVE&$res)
	If $resErr or ($resType <> $CMD_RESULT_STRING)or($res<>$ChdkPlatform) Then
		testWriteLine($M_ERR)
	Else
		$testStatus = True
		testWriteLine($M_OK)
	EndIf

	If  Not $testStatus Then
		testWriteLine($M_ATT&" Der luar-Fehler ist aufgetreten")
		testWriteLine(@CRLF&getNextCount()&"Prfung auf Kameraabschaltung durch den Fehler")
		$cmd = "version"
		testWriteLine($M_SEND&$cmd)
		$res = setCommand($cmd,0)
		$resType = @extended
		$resErr = @error
		testWrite($M_RECEIVE&$res)
		If $resErr or ($resType <> $CMD_RESULT_MULTILINE) Then
			testWriteLine($M_ERR)
		Else
			testWriteLine($M_OK)
		EndIf
	EndIf

	If $testStatus Then $testStatusText = $TS_GOOD
	testWriteLine(@CRLF&$M_INFO&"Test abgeschlossen!")
	testWriteLine($M_RES&"Ergebnis: "&$testStatusText)
	Return 0
EndFunc

